/*******************************************************************************
 * FogVolumeDensityInfo generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FogVolumeDensityInfo extends Info
    abstract
    native(FogVolume)
    notplaceable
    hidecategories(Navigation,Collision)
    classgroup(Fog)
    autoexpandcategories(FogVolumeDensityInfo);

struct CheckpointRecord
{
    var bool bEnabled;

    structdefaultproperties
    {
        bEnabled=false
    }
};

var() export editinline FogVolumeDensityComponent DensityComponent;
var() export editinline StaticMeshComponent AutomaticMeshComponent;
var repnotify bool bEnabled;

replication
{
    // Pos:0x000
    if(Role == ROLE_Authority)
        bEnabled
}

event PostBeginPlay()
{
    super(Actor).PostBeginPlay();
    // End:0x43
    if(DensityComponent != none)
    {
        bEnabled = DensityComponent.bEnabled;
    }
    //return;    
}

simulated event ReplicatedEvent(name VarName)
{
    // End:0x43
    if(VarName == 'bEnabled')
    {
        DensityComponent.SetEnabled(bEnabled);
    }
    // End:0x56
    else
    {
        super(Actor).ReplicatedEvent(VarName);
    }
    //return;    
}

simulated function OnToggle(SeqAct_Toggle Action)
{
    // End:0x5A
    if(Action.InputLinks[0].bHasImpulse)
    {
        DensityComponent.SetEnabled(true);
    }
    // End:0x12C
    else
    {
        // End:0xB4
        if(Action.InputLinks[1].bHasImpulse)
        {
            DensityComponent.SetEnabled(false);
        }
        // End:0x12C
        else
        {
            // End:0x12C
            if(Action.InputLinks[2].bHasImpulse)
            {
                DensityComponent.SetEnabled(!DensityComponent.bEnabled);
            }
        }
    }
    bEnabled = DensityComponent.bEnabled;
    ForceNetRelevant();
    SetForcedInitialReplicatedProperty(boolproperty'bEnabled', bEnabled == default.bEnabled);
    //return;    
}

function bool ShouldSaveForCheckpoint()
{
    return RemoteRole != ROLE_None;
    //return ReturnValue;    
}

function CreateCheckpointRecord(out CheckpointRecord Record)
{
    Record.bEnabled = bEnabled;
    //return;    
}

function ApplyCheckpointRecord(const out CheckpointRecord Record)
{
    bEnabled = Record.bEnabled;
    DensityComponent.SetEnabled(bEnabled);
    ForceNetRelevant();
    SetForcedInitialReplicatedProperty(boolproperty'bEnabled', bEnabled == default.bEnabled);
    //return;    
}

defaultproperties
{
    begin object name=AutomaticMeshComponent0 class=StaticMeshComponent
        StaticMesh=StaticMesh'EngineMeshes.Cube'
        WireframeColor=(R=100,G=100,B=200,A=255)
        ReplacementPrimitive=none
        bIgnoreOwnerHidden=true
        bUseAsOccluder=false
        bSelectable=false
        bAcceptsStaticDecals=false
        bAcceptsDynamicDecals=false
        CastShadow=false
        bCastDynamicShadow=false
        bAcceptsLights=false
        bAcceptsDynamicLights=false
        BlockRigidBody=false
    object end
    // Reference: StaticMeshComponent'Default__FogVolumeDensityInfo.AutomaticMeshComponent0'
    AutomaticMeshComponent=AutomaticMeshComponent0
    Components(0)=none
    begin object name=AutomaticMeshComponent0 class=StaticMeshComponent
        StaticMesh=StaticMesh'EngineMeshes.Cube'
        WireframeColor=(R=100,G=100,B=200,A=255)
        ReplacementPrimitive=none
        bIgnoreOwnerHidden=true
        bUseAsOccluder=false
        bSelectable=false
        bAcceptsStaticDecals=false
        bAcceptsDynamicDecals=false
        CastShadow=false
        bCastDynamicShadow=false
        bAcceptsLights=false
        bAcceptsDynamicLights=false
        BlockRigidBody=false
    object end
    // Reference: StaticMeshComponent'Default__FogVolumeDensityInfo.AutomaticMeshComponent0'
    Components(1)=AutomaticMeshComponent0
    bNoDelete=true
}